# screeps typing
class st:  # ScreepsTyping
    """
    st提供了一组形如st.funcx(obj)->bool的函数:</br>
        1. 用于判断一个对象是否是某种js类型，这类函数一般以jxxxx命名</br>
        2. 用于判断一个对象是否是某种py类型，这类函数一般以对应python对象名命名</br>
        3. 用于判断一个对象是否是某种游戏对象类型</br>
        4. 用于判断一个对象是否具有某种能力</br>
    """
    # -------------- JS基础类型判断 | JS Basic Type Judgment -----------------
    NOT_JNUMBER = ""
    NOT_JLIST = ""
    NOT_JDICT = ""
    NOT_JSTRING = ""
    NOT_JBOOL = ""
    # -------------- PY基础类型判断 | PY Basic Type Judgment -----------------
    NOT_LIST = ""
    NOT_TUPLE = ""
    NOT_DICT = ""
    NOT_SET = ""
    NOT_STR = ""
    NOT_INT = ""
    NOT_FLOAT = ""
    NOT_BOOL = ""
    # -------------- 游戏对象类型判断 | Game Object Type Judgment -----------------
    NOT_SITE = ""
    NOT_CREEP = ""
    NOT_GOBJECT = ""
    NOT_OSTRUCTURE = ""
    NOT_RESOURCE = ""
    NOT_SOURCE = ""
    NOT_STORE = ""
    NOT_STRUCTURE = ""
    NOT_BOX = ""
    NOT_EXTENSION = ""
    NOT_RAMPART = ""
    NOT_ROAD = ""
    NOT_SPAWN = ""
    NOT_TOWER = ""
    NOT_WALL = ""
    NOT_SPAWNING = ""
    NOT_FLAG = ""
    NOT_POINT = ""
    # -------------- 对象能力类型判断 | Object Ability Type Judgment -----------------
    NOT_MOVABLE = ""
    NOT_ATKABLE = ""
    NOT_MELEE = ""
    NOT_RANGED = ""
    NOT_HEALABLE = ""
    NOT_HITABLE = ""
    NOT_WORKABLE = ""
    NOT_STORABLE = ""
    NOT_ENERGETIC = ""
    NOT_DAMAGED = ""
    NOT_EMPTY = ""
    NOT_FULL = ""
    NOT_MINE = ""
    NOT_FRIEND = ""
    NOT_ENEMY = ""
    # -------------- Other -----------------
    POOR = ""
    BUSY = ""
    INVALID = ""
    OUT_RANGE = ""

    # -------------------------------------- JS基础类型判断 | JS Basic Type Judgment -----------------
    @staticmethod
    def jnumber(obj: object) -> bool:
        """
        判断一个对象是否是js Number | Determine if an object is a js Number

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def jlist(obj: object) -> bool:
        """
        判断一个对象是否是js Array | Determine if an object is a js Array


        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def jstring(obj: object) -> bool:
        """
        判断一个对象是否是js String | Determine if an object is a js String

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def jbool(obj: object) -> bool:
        """
        判断一个对象是否是js Boolean | Determine if an object is a js Boolean

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def jdict(obj: object) -> bool:
        """
        判断一个对象是否是js Array  # js中dict是Array来实现的 |
            Determine if an object is a js Array  # dict is implemented as Array in js

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def na(obj: object) -> bool:
        """
        判断一个对象是否是py None | Determine if an object is py None
        * python的None由于翻译可能有问题，有时会翻译为Null或者undefined，所以使用该函数代替is None检查 |
            Because the translation of python's None may have problems, sometimes it may be translated as Null or undefined, so use this function instead of 'is None' check

        Args:
            obj:

        Returns:

        """
        pass

    # -------------------------------------- PY基础类型判断 | PY Basic Type Judgment -----------------

    @staticmethod
    def list(obj: object) -> bool:
        """
        判断一个对象是否是py list | Determine if an object is a py list


        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def tuple(obj: object) -> bool:
        """
        判断一个对象是否是py tuple | Determine if an object is a py tuple

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def dict(obj: object) -> bool:
        """
        判断一个对象是否是py dict | Determine if an object is a py dict

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def set(obj: object) -> bool:
        """
        判断一个对象是否是py set | Determine if an object is a py set

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def str(obj: object) -> bool:
        """
        判断一个对象是否是py str | Determine if an object is a py str

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def int(obj: object) -> bool:
        """
        判断一个对象是否是py int | Determine if an object is a py int

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def float(obj: object) -> bool:
        """
        判断一个对象是否是py float | Determine if an object is a py float

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def bool(obj: object) -> bool:
        """
        判断一个对象是否是py bool | Determine if an object is a py bool

        Args:
            obj:

        Returns:

        """
        pass

    # -------------------------------------- 游戏对象类型判断 | Game Object Type Judgment -----------------

    @staticmethod
    def site(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:ConstructionSite | Determine if an object is a game object:ConstructionSite

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def creep(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Creep | Determine if an object is a game object:Creep

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def gobject(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象 | Determine if an object is a game object

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def ostructure(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:OwnedStructure | Determine if an object is a game object:OwnedStructure

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def resource(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Resource | Determine if an object is a game object:Resource

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def source(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Source | Determine if an object is a game object:Source

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def store(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Store | Determine if an object is a game object:Store

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def structure(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Structure | Determine if an object is a game object:Structure

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def box(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:StructureContainer | Determine if an object is a game object:StructureContainer

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def extension(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:StructureExtension | Determine if an object is a game object:StructureExtension

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def rampart(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:StructureRampart | Determine if an object is a game object:StructureRampart

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def road(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:StructureRoad | Determine if an object is a game object:StructureRoad

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def spawn(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Spawn | Determine if an object is a game object:Spawn

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def tower(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:StructureTower | Determine if an object is a game object:StructureTower

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def wall(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:StructureWall | Determine if an object is a game object:StructureWall

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def spawning(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Spawning | Determine if an object is a game object:Spawning

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def flag(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Flag | Determine if an object is a game object:Flag

        Args:
            obj:

        Returns:

        """
        pass

    # -------------------------------------- 对象能力判断 | Object Ability Type Judgment -----------------

    @staticmethod
    def builtable(obj: object) -> bool:
        """
        判断一个game object是否是site并且可以进度未满 | Determine if a game object is a site and can progress not full

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def movable(obj: object) -> bool:
        """
        判断一个game object是否可以移动 | Determine if a game object can move

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def atkable(obj: object) -> bool:
        """
        判断一个game object是否可以攻击(或远程攻击) | Determine if a game object can attack (or ranged attack)

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def melee(obj: object) -> bool:
        """
        判断一个game object是否可以近战攻击 | Determine if a game object can melee attack

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def ranged(obj: object) -> bool:
        """
        判断一个game object是否可以远程攻击 | Determine if a game object can ranged attack

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def healable(obj: object) -> bool:
        """
        判断一个game object是否可以治疗他人 | Determine if a game object can heal others

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def hitable(obj: object) -> bool:
        """
        判断一个game object是否可以被攻击 | Determine if a game object can be attacked

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def workable(obj: object) -> bool:
        """
        判断一个game object是否可以工作 | Determine if a game object can work

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def storable(obj: object) -> bool:
        """
        判断一个game object是否可以储存资源(和现有资源情况无关) | Determine if a game object can store resources (regardless of the current resource situation)

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def energetic(obj: object) -> bool:
        """
        判断一个game object是否可以被单位拿取到能量 | Determine if a game object can be picked up by a unit

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def damaged(obj: object) -> bool:
        """
        判断一个game object是否受损 | Determine if a game object is damaged

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def empty(obj: object) -> bool:
        """
        判断一个对象的store是否为空(特指RESOURCE_ENERGY) | Determine if an object's store is empty (specifically RESOURCE_ENERGY)

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def full(obj: object) -> bool:
        """
        判断一个对象的store是否满(特指RESOURCE_ENERGY) | Determine if an object's store is full (specifically RESOURCE_ENERGY)

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def friend(obj: object) -> bool:
        """
        判断一个game object是否是友方 | Determine if a game object is friendly

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def my(obj: object) -> bool:
        """
        判断一个game object是否是己方 | Determine if a game object is my

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def enemy(obj: object) -> bool:
        """
        判断一个game object是否是敌方 | Determine if a game object is an enemy

        Args:
            obj:

        Returns:

        """
        pass

    @staticmethod
    def point(obj: object) -> bool:
        """
        判断一个对象是否是一个坐标点(具有x和y属性) | Determine if an object is a coordinate point (with x and y properties)

        Args:
            obj:

        Returns:

        """
        pass
