// > sort 3
import {LANGUAGE} from "../build/main.mjs";

export var DONE = 1;

const creep_getter_stringfn = function (creep) {
    let name = creep.name!==undefined?creep.name:creep.id;
    let storable = st.storable(creep, false);
    let score_string = LANGUAGE==="cn"?`得分:${creep.score},`:`score:${creep.score},`;
    return function (){
        if (!creep.exists) return LANGUAGE==="cn"?`Creep: ${name}[已阵亡]`:`Creep: ${name}[Dead]`;
        let health_string = LANGUAGE==="cn"?`生命值:${creep.hits}/${creep.hitsMax},`:`hp:${creep.hits}/${creep.hitsMax},`;
        let store_string = storable?LANGUAGE==="cn"?`资源:${creep.store.getUsedCapacity()}/${creep.store.getCapacity()}`:`rs:${creep.store.getUsedCapacity()}/${creep.store.getCapacity()}`:"";
        return `Creep: ${name}, (${creep.x}, ${creep.y}) [${score_string} ${health_string} ${store_string}];`;
    };
}

const spawn_getter_stringfn = function (spawn) {
    return function (){
        let name = spawn.id;
        if (!spawn.exists) if (LANGUAGE === "cn") return `Spawn: ${name} 已被移除;`; else return `Spawn: ${name} Removed;`;
        let store = spawn.store;
        let spawning = spawn.spawning;
        let spawning_string = spawning?`${
            LANGUAGE==="cn"?`正在孵化:${spawning.name} ${spawning.remainingTime}t`:`spawning:${spawning.name} ${spawning.remainingTime}t`
        }:${spawning.creep.name!==undefined?spawning.creep.name:spawning.creep.id}`:"";
        if (LANGUAGE==="cn") return `Spawn: ${name} (${spawn.x}, ${spawn.y}) 生命值:${spawn.hits}/${spawn.hitsMax} 资源:${store.getUsedCapacity(RESOURCE_ENERGY)}/${store.getCapacity(RESOURCE_ENERGY)} ${spawning_string};`;
        return `Spawn: ${name} (${spawn.x}, ${spawn.y}) hp:${spawn.hits}/${spawn.hitsMax} rs:${store.getUsedCapacity(RESOURCE_ENERGY)}/${store.getCapacity(RESOURCE_ENERGY)} ${spawning_string};`;
    };
}

const box_getter_stringfn = function (box) {
    return function (){
        let name = box.id;
        if (!box.exists) if (LANGUAGE === "cn") return `Box: ${name} 已被移除;`; else return `Box: ${name} Removed;`;
        let store = box.store;
        if (LANGUAGE === "cn") return `Box: ${name} (${box.x}, ${box.y}) 资源:${store.getUsedCapacity()}/${store.getCapacity()};`;
        return `Box: ${name} (${box.x}, ${box.y}) rs:${store.getUsedCapacity()}/${store.getCapacity()};`;
    };
}

const road_getter_stringfn = function (road) {
    return function (){
        let name = road.id;
        if (!road.exists) if (LANGUAGE === "cn") return `Road: ${name} 已被移除;`; else return `Road: ${name} Removed;`;
        if (LANGUAGE === "cn") return `Road: ${name} (${road.x}, ${road.y}) hp:${road.hits}/${road.hitsMax};`;
        return `Road: ${name} (${road.x}, ${road.y}) hp:${road.hits}/${road.hitsMax};`;
    };
}

const rampart_getter_stringfn = function (rampart) {
    return function (){
        let name = rampart.id;
        if (!rampart.exists) if (LANGUAGE === "cn") return `Rampart: ${name} 已被移除;`; else return `Rampart: ${name} Removed;`;
        if (LANGUAGE === "cn") return `Rampart: ${name} (${rampart.x}, ${rampart.y}) hp:${rampart.hits}/${rampart.hitsMax};`;
        return `Rampart: ${name} (${rampart.x}, ${rampart.y}) hp:${rampart.hits}/${rampart.hitsMax};`;
    };
}

const tower_getter_stringfn = function (tower) {
    return function (){
        let name = tower.id;
        if (!tower.exists) if (LANGUAGE === "cn") return `Tower: ${name} 已被移除;`; else return `Tower: ${name} Removed;`;
        let store = tower.store;
        if (LANGUAGE === "cn") return `Tower: ${name} (${tower.x}, ${tower.y}) 生命值:${tower.hits}/${tower.hitsMax} 资源:${store.getUsedCapacity()}/${store.getCapacity()};`;
        return `Tower: ${name} (${tower.x}, ${tower.y}) hp:${tower.hits}/${tower.hitsMax} rs:${store.getUsedCapacity()}/${store.getCapacity()};`;
    };
}

const gameobject_getter_stringfn = function (gameobject) {
    return function (){
        let name = gameobject.id;
        if (!gameobject.exists) if (LANGUAGE === "cn") return `GameObject: ${name} 已被移除;`; else return `GameObject: ${name} Removed;`;
        if (LANGUAGE === "cn") return `GameObject: ${name} (${gameobject.x}, ${gameobject.y});`;
        return `GameObject: ${name} (${gameobject.x}, ${gameobject.y});`;
    };
}

const check_and_set_stringfn = function (obj) {
    if (obj === null || obj === undefined) return;
    if (obj.toString_FLAG) return;
    obj.toString_FLAG = true;
    if    (obj instanceof Creep)          obj.toString = creep_getter_stringfn(obj);
    else if (obj instanceof StructureSpawn) obj.toString = spawn_getter_stringfn(obj);
    else if (obj instanceof StructureContainer) obj.toString = box_getter_stringfn(obj);
    else if (obj instanceof StructureRoad) obj.toString = road_getter_stringfn(obj);
    else if (obj instanceof StructureRampart) obj.toString = rampart_getter_stringfn(obj);
    else if (obj instanceof StructureTower) obj.toString = tower_getter_stringfn(obj);
    else if (obj instanceof GameObject) obj.toString = gameobject_getter_stringfn(obj);
}

export var get = {
    ticks: getTicks,
    cpu: getCpuTime,
    heap: getHeapStatistics,
    byid: getObjectById,
    cpu_us: function () {
        return Math.floor(getCpuTime() / 1000);
    },
    get arena() {
        return function () {
            var tmp = UsrObject();
            tmp.py_name = ARENA_NAME;
            tmp.level = ARENA_LEVEL;
            tmp.season = ARENA_SEASON;
            tmp.ticksLimit = ARENA_TICKS_LIMIT;
            tmp.cpuTimeLimit = ARENA_CPU_TIME_LIMIT;
            tmp.cpuTimeLimitFirstTick = ARENA_CPU_TIME_LIMIT_FIRST_TICK;
            return tmp;
        };
    },
    distance: function (obj, target) {
        if (target === null || target === undefined) {
            if (LANGUAGE === "cn") std.warn('get.distance', '目标{target}为空。返回65535');
            else std.warn('get.distance', 'target is NA. Return 65535');
            return 65535;
        }
        if (obj === null || obj === undefined) {
            if (LANGUAGE === "cn") std.warn('get.distance', '对象为空{obj}。返回65535');
            else std.warn('get.distance', 'obj is NA. Return 65535');
            return 65535;
        }
        if (obj.x === undefined || obj.y === undefined || target.x === undefined || target.y === undefined) {
            if (LANGUAGE === "cn") std.warn('get.distance', '对象{obj}或目标{target}不是一个点{包含.x和.y}。返回65535');
            else std.warn('get.distance', 'obj or target is not a point. Return 65535');
            return 65535;
        }
        return Math.max(Math.abs(obj.x - target.x), Math.abs(obj.y - target.y));
    },
    path: function (obj, target, options = null) {
        if (target === null || target === undefined) {
            if (LANGUAGE === "cn") std.warn('get.path', '目标{target}为空。返回null');
            else std.warn('get.path', 'target is NA. Return null');
            return null;
        }
        if (obj === null || obj === undefined) {
            if (LANGUAGE === "cn") std.warn('get.path', '对象为空{obj}。返回null');
            else std.warn('get.path', 'obj is NA. Return null');
            return null;
        }
        var path_res = searchPath(obj, target, options);
        if (path_res.incomplete) {
            if (LANGUAGE === "cn") std.warn('get.path', '目标{' + target.id.toString() + '}的路径不完整。');
            else std.warn('get.path', 'Path to target:', target.id, ' is incomplete.');
        }
        return path_res.path;
    },
    find: function (objs, filter_fn) {
        if (len(objs) === 0) {
            return null;
        }
        if (filter_fn === undefined || filter_fn === null) {
            if (LANGUAGE === "cn") std.warn('get.find', '过滤函数为空。默认返回第一个对象');
            else std.warn('get.find', 'filter_fn is NA. Return first object');
        } else {
            if (isinstance(filter_fn, tuple([list, tuple, set]))) {
                filter_fn = std.combo(filter_fn);
            }
            objs = filter(filter_fn, objs);
        }
        return len(objs) ? objs[0] : null;
    },
    filter: function (objs, filter_fn) {
        if (len(objs) === 0) {
            return objs;
        }
        if (filter_fn === undefined || filter_fn === null) {
            if (LANGUAGE === "cn") std.warn('get.filter', '过滤函数为空。返回原数组|列表。');
            else std.warn('get.filter', 'filter_fn is NA. Return the original array|list.');
        } else {
            if (isinstance(filter_fn, tuple([list, tuple, set]))) {
                filter_fn = std.combo(filter_fn);
            }
            return filter(filter_fn, objs);
        }
        return objs;
    },
    classname: function (game_object) {
        if (game_object instanceof Creep) return 'Creep';
        if (game_object instanceof StructureSpawn) return 'Spawn';
        if (game_object instanceof StructureExtension) return 'Extension';
        if (game_object instanceof StructureRoad) return 'Road';
        if (game_object instanceof StructureWall) return 'Wall';
        if (game_object instanceof StructureRampart) return 'Rampart';
        if (game_object instanceof StructureTower) return 'Tower';
        if (game_object instanceof Structure) return 'Structure';
        if (game_object instanceof Source) return 'Source';
        try{if (game_object instanceof Flag) return 'Flag';} catch(e){}
        if (game_object instanceof ConstructionSite) return 'Site';
        if (game_object instanceof Resource) return 'Resource';
        if (game_object instanceof GameObject) return 'GameObject';
        return 'Object';
    },
    terrain: function (x_or_point, y) {
        if (x_or_point === null || x_or_point === undefined) {
            if (LANGUAGE === "cn") std.warn('get.terrain', 'x_or_point为空。返回null');
            else std.warn('get.terrain', 'x_or_point is NA. Return null');
            return null;
        }
        if (y === null || y === undefined) {
            if (x_or_point.x === undefined || x_or_point.y === undefined) {
                if (LANGUAGE === "cn") std.warn('get.terrain', 'x_or_point不是一个点。返回null');
                else std.warn('get.terrain', 'x_or_point is not a point. Return null');
                return null;
            }

            return getTerrainAt(x_or_point);
        }
        return getTerrainAt(Point(x_or_point, y));
    },
    all: function (p_type, filter_fn = null) {
        var objs = getObjectsByPrototype(p_type);
        if (p_type === Creep) {
            var tmp = [];
            for (var obj of objs) {
                if (obj.score === undefined)  obj.score = get.score(obj);
                if ((obj.my === false) || (obj.__spawn__ !== undefined)) {
                    tmp.append(obj);
                }
            }
            objs = tmp;
        }
        if (filter_fn !== undefined && filter_fn !== null) {
            if (isinstance(filter_fn, tuple([list, tuple, set]))) {
                filter_fn = std.combo(filter_fn);
            }
            objs = filter(filter_fn, objs);
        }
        for (const it of objs) {
            if (it.toString_FLAG) continue;
            check_and_set_stringfn(it);
        }
        return objs;
    },
    one: function (p_type, filter_fn = null) {
        var objs = get.all(p_type, filter_fn);
        if (len(objs) === 0) {
            return null;
        }
        return objs[0];
    },
    creeps: function (filter_fn = null) {
        return get.all(Creep, filter_fn);
    },
    creep: function (filter_fn = null) {
        return get.one(Creep, filter_fn);
    },
    friends: function (filter_fn = null) {
        return get.all(Creep, function (obj) {
            return obj.my && (!(filter_fn) || filter_fn(obj));
        });
    },
    friend: function (filter_fn = null) {
        return get.one(Creep, function (obj) {
            return obj.my && (!(filter_fn) || filter_fn(obj));
        });
    },
    enemies: function (filter_fn = null) {
        return get.all(Creep, function (obj) {
            return !(obj.my) && (!(filter_fn) || filter_fn(obj));
        });
    },
    enemy: function (filter_fn = null) {
        return get.one(Creep, function (obj) {
            return !(obj.my) && (!(filter_fn) || filter_fn(obj));
        });
    },
    spawns: function (filter_fn = null) {
        return get.all(StructureSpawn, filter_fn);
    },
    spawn: function (filter_fn = null) {
        return get.one(StructureSpawn, filter_fn);
    },
    structures: function (filter_fn = null) {
        return get.all(Structure, filter_fn);
    },
    structure: function (filter_fn = null) {
        return get.one(Structure, filter_fn);
    },
    sources: function (filter_fn = null) {
        return get.all(Source, filter_fn);
    },
    source: function (filter_fn = null) {
        return get.one(Source, filter_fn);
    },
    sites: function (filter_fn = null) {
        return get.all(ConstructionSite, filter_fn);
    },
    site: function (filter_fn = null) {
        return get.one(ConstructionSite, filter_fn);
    },
    resources: function (filter_fn = null) {
        return get.all(Resource, filter_fn);
    },
    resource: function (filter_fn = null) {
        return get.one(Resource, filter_fn);
    },
    towers: function (filter_fn = null) {
        return get.all(StructureTower, filter_fn);
    },
    tower: function (filter_fn = null) {
        return get.one(StructureTower, filter_fn);
    },
    walls: function (filter_fn = null) {
        return get.all(StructureWall, filter_fn);
    },
    wall: function (filter_fn = null) {
        return get.one(StructureWall, filter_fn);
    },
    ramparts: function (filter_fn = null) {
        return get.all(StructureRampart, filter_fn);
    },
    rampart: function (filter_fn = null) {
        return get.one(StructureRampart, filter_fn);
    },
    extensions: function (filter_fn = null) {
        return get.all(StructureExtension, filter_fn);
    },
    extension: function (filter_fn = null) {
        return get.one(StructureExtension, filter_fn);
    },
    boxes: function (filter_fn = null) {
        return get.all(StructureContainer, filter_fn);
    },
    box: function (filter_fn = null) {
        return get.one(StructureContainer, filter_fn);
    },
    roads: function (filter_fn = null) {
        return get.all(StructureRoad, filter_fn);
    },
    road: function (filter_fn = null) {
        return get.one(StructureRoad, filter_fn);
    },
    flags: function (filter_fn = null) {
        return get.all(Flag, filter_fn);
    },
    flag: function (filter_fn = null) {
        return get.one(Flag, filter_fn);
    },
    gobjects: function (filter_fn = null) {
        return get.all(GameObject, filter_fn);
    },
    gobject: function (filter_fn = null) {
        return get.one(GameObject, filter_fn);
    },
    score_controllers: function (filter_fn = null) {
        return get.all(ScoreController, filter_fn);
    },
    score_controller: function (filter_fn = null) {
        return get.one(ScoreController, filter_fn);
    },
    storages: function (filter_fn = null) {
        return get.all(GameObject, function (obj) {
            return st.storable(obj) && filter_fn(obj);
        });
    },
    storage: function (filter_fn = null) {
        return get.one(GameObject, function (obj) {
            return st.storable(obj) && filter_fn(obj);
        });
    },
    moved: function (unit, ticks_offset = 0) {
        return unit.last_move === (know.now + ticks_offset);
    },
    attacked: function (unit, ticks_offset = 0) {
        return unit.last_attack === (know.now + ticks_offset) || unit.last_ranged === (know.now + ticks_offset);
    },
    meleed: function (unit, ticks_offset = 0) {
        return unit.last_melee === (know.now + ticks_offset);
    },
    ranged: function (unit, ticks_offset = 0) {
        return unit.last_ranged === (know.now + ticks_offset);
    },
    healed: function (unit, ticks_offset = 0) {
        return unit.last_heal === (know.now + ticks_offset);
    },
    fetched: function (unit, ticks_offset = 0) {
        return unit.last_fetch === (know.now + ticks_offset);
    },
    deposited: function (unit, ticks_offset = 0) {
        return unit.last_deposit === (know.now + ticks_offset);
    },
    built: function (unit, ticks_offset = 0) {
        return unit.last_build === (know.now + ticks_offset);
    },
    intermited: function (unit, ticks_offset = 0) {
        return unit.last_intermit === (know.now + ticks_offset);
    },
    closest: function (obj, objs, filter_fn = null) {
        if (len(objs) === 0) {
            return null;
        }
        if (filter_fn !== undefined && filter_fn !== null) {
            if (isinstance(filter_fn, tuple([list, tuple, set]))) {
                filter_fn = std.combo(filter_fn);
            }
            objs = filter(filter_fn, objs);
        }
        if (len(objs) === 0) {
            if (LANGUAGE === "cn") std.warn('get.closest', '过滤后没有剩余对象。');
            else std.warn('get.closest', 'No objects left after filtering.')
            return null;
        }
        var ret = findClosestByRange(obj, objs);
        if (ret === undefined) {
            return null;
        }
        return ret;
    },
    quickest: function (obj, objs, filter_fn = undefined, options = undefined) {
        if (len(objs) === 0) {
            return null;
        }
        if (filter_fn !== undefined && filter_fn !== null) {
            if (isinstance(filter_fn, tuple([list, tuple, set]))) {
                filter_fn = std.combo(filter_fn);
            }
            objs = filter(filter_fn, objs);
        }
        if (len(objs) === 0) {
            if (LANGUAGE === "cn") std.warn('get.quickest', '过滤后没有剩余对象。');
            else std.warn('get.quickest', 'No objects left after filtering.')
            return null;
        }
        var ret = findClosestByPath(obj, objs, options);
        if (ret === undefined) {
            return null;
        }
        return ret;
    },
    inrange: function (obj, objs, range, filter_fn = null) {
        if (len(objs) === 0) {
            return objs;
        }
        if (filter_fn !== undefined && filter_fn !== null) {
            if (isinstance(filter_fn, tuple([list, tuple, set]))) {
                filter_fn = std.combo(filter_fn);
            }
            objs = filter(filter_fn, objs);
        }
        if (len(objs) === 0) {
            if (LANGUAGE === "cn") std.warn('get.inrange', '过滤后没有剩余对象。');
            else std.warn('get.inrange', 'No objects left after filtering.')
            return null;
        }
        var tmp = [];
        for (var _obj of objs) {
            if (get.distance(obj, _obj) <= range) {
                tmp.append(_obj);
            }
        }
        return tmp;
    },
    cluster: function (obj, objs, range, filter_fn=null){
        /// 将所有objs视作开放列表
        if (len(objs) === 0) {
            return objs;
        }
        if (filter_fn !== undefined && filter_fn !== null) {
            if (isinstance(filter_fn, tuple([list, tuple, set]))) {
                filter_fn = std.combo(filter_fn);
            }
            objs = filter(filter_fn, objs);
        }
        if (len(objs) === 0) {
            if (LANGUAGE === "cn") std.warn('get.cluster', '过滤后没有剩余对象。');
            else std.warn('get.cluster', 'No objects left after filtering.')
            return objs;
        }
        var openList = [];
        var closeList = [];
        for (var _obj of objs) {
            if (get.distance(obj, _obj) <= range) {
                closeList.append(_obj);
            } else {
                openList.append(_obj);
            }
        }
        while (len(openList) > 0) {
            var tmp = openList.shift();
            for (var _obj of closeList) {
                if (get.distance(tmp, _obj) <= range) {
                    closeList.append(tmp);
                    break;
                }
            }
        }
        return closeList;
    },
    energy: function (target, percent = false) {
        if (target === null || !(target.store)) {
            return -(1);
        }
        var current = target.store.getUsedCapacity(RESOURCE_ENERGY);
        if (current === null) {
            return -(1);
        }
        var value = current;
        if (percent) {
            var total = target.store.getCapacity(RESOURCE_ENERGY);
            if (total === null) {
                return -(1);
            }
            value = current / total
        }
        return value;
    },
    health: function (target, percent = false) {
        if (target === null) {
            return 0;
        }
        if (target.hits === undefined) {
            return 0;
        }
        var current = target.hits;
        var value = current;
        if (percent) {
            if (target.hitsMax === undefined) {
                return 0;
            }
            var total = target.hitsMax;
            value = current / total
        }
        return value;
    },
    parts: function (creep, broken = true) {
        if (!(creep) || !(creep.body)) {
            return [];
        }
        var prts = [];
        for (var prt of creep.body) {
            if (!broken && prt.hits <= 0) continue;
            prts.append(prt.type);
        }
        return prts;
    },
    partCount: function (creep, part_type, broken = true) {
        if (!(creep) || !(creep.body)) {
            return -(1);
        }
        var count = 0;
        for (var part of creep.body) {
            if (part.type === part_type) {
                if (broken || part.hits > 0) {
                    count++;
                }
            }
        }
        return count;
    },
    partFirst: function (creep) {
        if (!(creep) || !(creep.body)) {
            return null;
        }
        for (var part of creep.body) {
            if (part.hits > 0) {
                return part;
            }
        }
        return null;
    },
    partLast: function (creep) {
        if (!(creep) || !(creep.body)) {
            return null;
        }
        for (var part of py_reversed(creep.body)) {
            if (part.hits <= 0) {
                return part;
            }
        }
        return null;
    },
    wait: function (creep) {
        var move_count = get.partCount(creep, MOVE, false);
        if (move_count === -1) {
            return -1;
        }
        if (move_count === 0) {
            return 65535;
        }
        var fatigue = creep.fatigue;
        if (fatigue <= 0) {
            return 0;
        }
        return Math.ceil((fatigue / 2) / move_count);
    },
    offset: function (pos, dx, dy) {
        return Point(pos.x + dx, pos.y + dy);
    },
    SCORE_TABLE: dict([[ATTACK, 10], [RANGED_ATTACK, 15], [HEAL, 15], [TOUGH, 1], [MOVE, 2], [CARRY, 2], [WORK, 5]]),
    score: function (creep, dhp = null) {
        if (st.jnumber(dhp) && dhp > 0) {
            dhp = math.floor(dhp);
            var bk = get.partLast(creep);
            var fr = get.partFirst(creep);
            if (get.health(creep, true) === 100) {
                return 0;
            }
            var fs = int(get.SCORE_TABLE [fr.py_metatype] * (1 - fr.hits / 100));
            if (!(bk)) {
                return fs;
            }
            var bs = int(get.SCORE_TABLE [bk.py_metatype] * (1 - ((dhp - fr.hits) + 100) / 100));
            if (dhp > 100 - fr.hits) {
                return fs + bs;
            }
            return fs;
        } else {
            var __left0__ = tuple([0, 0, 0]);
            var carries = __left0__ [0];
            var moves = __left0__ [1];
            var score = __left0__ [2];
            var prts = get.parts(creep);
            for (var [i, prt] of enumerate(prts)) {
                if (prt === ATTACK) {
                    score += 10 + i / 5;
                } else if (prt === RANGED_ATTACK) {
                    score += 15 + i / 4;
                } else if (prt === HEAL) {
                    score += 15 + i;
                } else {
                    score++;
                    if (prt === MOVE) {
                        moves++;
                    } else if (prt === CARRY) {
                        carries++;
                    }
                }
            }
            var length = (len(prts) - carries) - moves;
            var movements = moves * 2;
            var move_cost = length * 10;
            if (length === 0) {
                var coef = 0;
            } else if (movements > move_cost) {
                var coef = 2;
            } else {
                var coef = (2 * movements) / move_cost;
            }
            var coef = (1 + coef) / 2;
            return math.floor(score * coef);
        }
    },
    PART_COST_TABLE:{},
    partCost: function (part) {
        return get.PART_COST_TABLE[part];
    },
    partsOptimise: function (parts) {
        // step1: 将所有的TOUGH部件放在最前面
        const tough_head = parts.filter(part => part === TOUGH);
        const rest_parts = parts.filter(part => part !== TOUGH);

        // step2 create order
        let order = [... new Set(rest_parts.reverse())];

        // step3 count 最少个数的种类
        const each_count = {};
        for (const kind of order) each_count[kind] = rest_parts.filter(part => part === kind).length;
        let min_count = Infinity;
        let min_kind = null;
        for (const kind of order)
            if (each_count[kind] < min_count) {
                min_count = each_count[kind];
                min_kind = kind;
            }

        // step4: 创建 unit_count = { each_count[k].count // min_count } 和 other_count = { each_count[k].count % min_count }
        const unit_count = {};
        const other_count = {};
        for (const kind of order) {
            unit_count[kind] = Math.floor(each_count[kind] / min_count);
            other_count[kind] = each_count[kind] % min_count;
        }

        // step5: create group_pattern. iter 'order', fetch same kind from unit_count if has. until all unit_count is 0
        let group_pattern = [];
        while (true){
            let flag = false;  // any push will set as true
            for (const kind of order) {
                if (unit_count[kind] > 0) {
                    group_pattern.push(kind);
                    unit_count[kind] -= 1;
                    flag = true;
                }
            }
            if (!flag) break;
        }
        group_pattern = group_pattern.reverse();

        // step6: create others_sequence. iter 'order', fetch same kind from other_count if has. until all other_count is 0
        const others_sequence = [];
        while (true){
            let flag = false;  // any push will set as true
            for (const kind of order) {
                if (other_count[kind] > 0) {
                    others_sequence.push(kind);
                    other_count[kind] -= 1;
                    flag = true;
                }
            }
            if (!flag) break;
        }

        // inner function: split others into min_count list. can be empty if not has enough
        const split_others = function (min_count, others_sequence) {
            if (min_count <= 1) return [others_sequence];
            const total = (min_count + 1) * min_count / 2;
            let last_idx = 0;
            let cur_idx = 0;
            const res = [];
            for (let i = min_count; i > 0; i--) {
                cur_idx = last_idx + (i / total) * others_sequence.length;
                last_idx = Math.ceil(last_idx);
                cur_idx = Math.ceil(cur_idx);
                res.push(others_sequence.slice(last_idx, cur_idx));
                last_idx = cur_idx;
            }
            return res;
        }

        // step7: split others_sequence into min_count list
        const others_splits = split_others(min_count, others_sequence);

        // step: special optimise:
        // ignore carry, if MOVE * 5  < others: ...
        const tails = [];
        const move_count = each_count[MOVE];
        let not_move_count = 0;
        for (const kind of order) {
            if (kind === MOVE) continue;
            if (kind === CARRY) continue;
            not_move_count += each_count[kind];
        }
        if ((move_count * 2) < (not_move_count * 5)) {
            // 将others_splits[0]中的所有MOVE部件移动到tails中
            const moves = others_splits[0].filter(part => part === MOVE);
            tails.push(...moves);
            others_splits[0] = others_splits[0].filter(part => part !== MOVE);
        } else if (move_count < not_move_count * 5) {
            // 将others_splits[0]中的半数(向上取整)MOVE部件移动到tails中
            const moves = others_splits[0].filter(part => part === MOVE);
            const move_count = Math.ceil(moves.length / 2);
            tails.push(...moves.slice(0, move_count));
            for (let i = 0; i < move_count; i++)
                others_splits[0].remove(MOVE);
        }

        // step8: merge HEAD + (others_splits[i] + group_pattern) + (others_splits[i+1] + group_pattern) + ...
        let res = [];
        res.push(...tough_head);
        for (let i = 0; i < min_count; i++) {
            res.push(...others_splits[i]);
            res.push(...group_pattern);
        }
        res.push(...tails);


        // 提出所有HEAL部件，但是保留最后一个(如果有的话)
        const heals = res.filter(part => part === HEAL);
        if (heals.length > 1) {
            heals.shift();
            for (const heal of heals) res.remove(heal);
            // 找到最后一个HEAL部件，将其余的HEAL部件插入在此
            const last_heal = res.indexOf(HEAL);
            res.splice(last_heal, 0, ...heals);
        }

        return res;
    },
    cost: function (creep_recipe) {
        if (creep_recipe instanceof Creep) {
            creep_recipe = get.parts(creep_recipe);
        }
        var cost = 0;
        for (var part of creep_recipe) {
            cost += get.partCost(part);
        }
        return cost;
    },
    /// GRAPH -------------------------------------------------------------------
    DEGREE_TABLE_REFLECT: {
        0: TOP,
        1: TOP_RIGHT,
        2: RIGHT,
        3: BOTTOM_RIGHT,
        4: BOTTOM,
        5: BOTTOM_LEFT,
        6: LEFT,
        7: TOP_LEFT,
    },
    direction: function(vec_point, target=undefined) {
        if (target !== undefined) {
            vec_point = Point(target.x - vec_point.x, target.y - vec_point.y);
        }
        let x=vec_point.x, y =vec_point.y;
        let theta = -math.atan2(y, x);  // 计算弧度
        let dtheta = math.degree(theta);  // 转换为度

        // 将角度范围调整到 [0, 360)
        if (dtheta < 0)
            dtheta += 360

        // 计算最接近的方向
        let dir_idx = math.floor((dtheta + 22.5) / 45) % 8

        return get.DEGREE_TABLE_REFLECT[dir_idx]
    },
    reversedDirection: function(direction) {
        return (direction + 3) % 8 + 1;
    },
    expandDirection: function(direction) {
        return [(direction + 6) % 8 + 1, direction, direction % 8 + 1];
    },
    DIRECTION_TO_DELTAPIONT:{
        1: {x:0, y:-1},
        2: {x:1, y:-1},
        3: {x:1, y:0},
        4: {x:1, y:1},
        5: {x:0, y:1},
        6: {x:-1, y:1},
        7: {x:-1, y:0},
        8: {x:-1, y:-1},
    },
    directionPoint: function(direction, base_point=undefined) {
        let point = get.DIRECTION_TO_DELTAPIONT[direction];
        if (base_point !== undefined) {
            return {x: base_point.x + point.x, y: base_point.y + point.y};
        }
        return point;
    },
    pooling: function(tarArr, kernelSize = 2) {
        /**
         * Pooling the array with kernelSize and stride with 'mean'
         *
         * @param {number[][]} tarArr - The target array
         * @param {number} kernelSize - The size of the kernel, strides will equal to kernelSize
         * @returns {number[][]} The pooled array
         */
        if (kernelSize < 2) {
            if (LANGUAGE === "cn") std.error("get.pooling", "池化核大小应大于1:", kernelSize);
            else std.error("get.pooling", "Kernel size should be greater than 1:", kernelSize);
        }
        if (tarArr.length < kernelSize || tarArr[0].length < kernelSize) {
            if (LANGUAGE === "cn") std.error("get.pooling", "数组大小应大于池化核大小:", len(tarArr), len(tarArr[0]));
            else std.error("get.pooling", "Array size should be greater than kernel size:", len(tarArr), len(tarArr[0]));
        }
        const res = [];
        const kSquare = kernelSize ** 2;
        const lenH = (Math.floor(tarArr.length / kernelSize)) * kernelSize;
        const lenW = (Math.floor(tarArr[0].length / kernelSize)) * kernelSize;
        for (let i = 0; i < lenH; i += kernelSize) {
            const newLine = [];
            for (let j = 0; j < lenW; j += kernelSize) {
                let sum = 0;
                for (let k = 0; k < kernelSize; k++) {
                    for (let l = 0; l < kernelSize; l++) {
                        sum += tarArr[i + k][j + l];
                    }
                }
                newLine.push(Math.floor(sum / kSquare));
            }
            res.push(newLine);
        }
        return res;
    },
    COST_MATRIX: [],
    costMatrix: function(start={x:0, y:0}, end={x:100, y:100}, __new__=false) {
        // 这个函数返回整个地图的对应roi区域的拷贝
        const ret = [];
        if (__new__) {
            for (let j = start.y; j < end.y; j++) {
                const newLine = [];
                for (let i = start.x; i < end.x; i++) {
                    newLine.push(get.terrain(i, j));
                }
                ret.push(newLine);
            }
            return ret;
        } else {
            for (let j = 0; j < end.y; j++) {
                const newLine = [];
                for (let i = start.x; i < end.x; i++) {
                    newLine.push(get.COST_MATRIX[j][i]);
                }
                ret.push(newLine);
            }
            return ret;
        }
    },
    shape: function(arr) {
        let rows = len(arr);
        if (rows === 0) return {x:0, y:0};
        return {x:len(arr[0]), y:rows};
    },
    slice2d: function(arr, start={x:0, y:0}, end=undefined) {
        const ret = [];
        if (end === undefined) end = get.shape(arr);
        for (let j = start.y; j < end.y; j++) {
            const newLine = [];
            for (let i = start.x; i < end.x; i++) {
                newLine.push(arr[j][i]);
            }
            ret.push(newLine);
        }
        return ret;
    },
    min2d: function(arr) {
        let min = Infinity;
        for (let i = 0; i < len(arr); i++) {
            min = Math.min(min, Math.min(...arr[i]));
        }
        return min;
    },
    max2d: function(arr) {
        let max = -Infinity;
        for (let i = 0; i < len(arr); i++) {
            max = Math.max(max, Math.max(...arr[i]));
        }
        return max;
    },
    sum2d: function(arr) {
        let sum = 0;
        for (let i = 0; i < len(arr); i++) {
            sum += sum(arr[i]);
        }
        return sum;
    },
    mean2d: function(arr) {
        return get.sum2d(arr) / (len(arr) * len(arr[0]));
    },
    poolingPrefab: function(psize) {
        if (psize === 1) return get.COST_MATRIX;
        if (psize === 2) return get.P2;
        if (psize === 4) return get.P4;
        if (psize === 5) return get.P5;
        if (psize === 8) return get.P8;
        if (psize === 10) return get.P10;
        // throw new Error("psize should be 1, 2, 4, 5, 8 or 10. Got: " + psize);
        if (LANGUAGE === "cn") std.error("get.poolingPrefab", "psize应为1, 2, 4, 5, 8或10。得到:", psize);
        else std.error("get.poolingPrefab", "psize should be 1, 2, 4, 5, 8 or 10. Got:", psize);
    },
    space2x:function (psize, x, y, rot = 0) {
        /**
         * Find a 2x psize square space with the base point x, y
         *
         * @param {number} psize - the size of the pool. (1, 2, 4, 5, 8, 10) corresponding to search space sizes (2x2, 4x4, 8x8, 10x10, 16x16, 20x20)
         * @param {number} x - the x position of the 100x100 space
         * @param {number} y - the y position of the 100x100 space
         * @param {number} rot - 0/1, indicating the spiral direction, 0 for counterclockwise left, 1 for counterclockwise right
         *
         * @returns {Object} the lt position of the 2x2 space
         */

        function calcMean2x2(arr, tx, ty) {
            /**
             * Calculate the mean of the 2x2 area
             *
             * @param {Array} arr
             * @param {number} tx
             * @param {number} ty
             *
             * @returns {number}
             */
            let sum = 0;
            for (let i = 0; i < 2; i++) {
                for (let j = 0; j < 2; j++) {
                    sum += arr[ty + j][tx + i];
                }
            }
            return Math.floor(sum / 4);
        }

        let pool = get.poolingPrefab(psize); // Assuming getPooling is defined elsewhere
        let pSize = psize;

        let width = pool[0].length;
        let height = pool.length;
        let tix = Math.floor(x / pSize);
        let tiy = Math.floor(y / pSize);
        let step = 1;
        let dirId = 0;
        let bestVal = 255;
        let bestPos = {x: x, y: y};

        let directs;
        if (rot) {
            directs = [[-1, 0], [0, 1], [1, 0], [0, -1]];
        } else {
            directs = [[1, 0], [0, -1], [-1, 0], [0, 1]];
        }

        // Start spiral search from the target point, calculate the mean of each 2x2 area, find the position with a value <= 10 and return it. If not found, return tix, tiy
        while (true) {
            for (let _ = 0; _ < 2; _++) {
                for (let _ = 0; _ < step; _++) {
                    if (0 <= tix && tix < (width - 1) && 0 <= tiy && tiy < (height - 1)) {
                        let val = calcMean2x2(pool, tix, tiy);
                        if (val <= 10) {
                            return {x: tix * pSize, y: tiy * pSize};
                        } else if (val < bestVal) {
                            bestVal = val;
                            bestPos = {x: tix * pSize, y: tiy * pSize};
                        }
                    } else if ((tix < 0 || tix >= width - 1) && (tiy < 0 || tiy >= height - 1)) {
                        return bestPos;
                    }
                    tix += directs[dirId][0];
                    tiy += directs[dirId][1];
                }
                dirId = (dirId + 1) % 4;
            }
            step += 1;
        }
    },
}

// new COST_MATRIX
get.COST_MATRIX = get.costMatrix({x:0, y:0}, {x:100, y:100}, true);
get.P2 = get.pooling(get.COST_MATRIX, 2);
get.P4 = get.pooling(get.P2, 2);
get.P5 = get.pooling(get.COST_MATRIX, 5);
get.P8 = get.pooling(get.P4, 2);
get.P10 = get.pooling(get.P5, 2);

get.PART_COST_TABLE[MOVE] = 50;
get.PART_COST_TABLE[WORK] = 100;
get.PART_COST_TABLE[CARRY] = 50;
get.PART_COST_TABLE[ATTACK] = 80;
get.PART_COST_TABLE[RANGED_ATTACK] = 150;
get.PART_COST_TABLE[HEAL] = 250;
get.PART_COST_TABLE[TOUGH] = 10;