class __Map {
    constructor(width, height){
        this._width = width;
        this._height = height;
        this.map = [];

        for (let ih = 0;ih < height;ih++){
            const tmp = [];
            for (let iw = 0;iw < width;iw++){
                tmp.push(get.terrain(iw, ih));
            }
            this.map.push(tmp);
        }

    }

    getNeighbour(ix, iy){
        const ret = [];
        for (let ih = iy-1;ih<iy+2;ih++){
            for (let iw = ix-1;iw<ix+2;iw++){
                if (ih === iy && iw === ix ) continue;
                if (ih < 0 || ih >= this._height || iw < 0 || iw >= this._width) continue;
                ret.push({x:iw, y:ih});
            }
        }
        return ret;
    }
    BFS(x0, y0){
        /// create heat map
        const heatMap = [];
        for (let ih = 0;ih < this._height;ih++){
            const tmp = [];
            for (let iw = 0;iw < this._width;iw++){
                tmp.push(null);
            }
            heatMap.push(tmp);
        }

        const queue = [];
        queue.push({x:x0, y:y0});
        heatMap[y0][x0] = 0;
        while (queue.length){
            const cur = queue.shift();
            const neighbours = this.getNeighbour(cur.x, cur.y);
            for (const n of neighbours){
                if (heatMap[n.y][n.x] === null && this.map[n.y][n.x] < 255) {
                    heatMap[n.y][n.x] = heatMap[cur.y][cur.x] + this.map[n.y][n.x];
                    queue.push(n)
                }
            }
        }

        return heatMap;
    }

    selectDirect(x0, y0, x1, y1){
        if (x0 === x1){
            if (y1 > y0) return "↓";
            if (y1 < y0) return "↑";
        } else if (x0 < x1){
            if (y1 > y0) return "↘";
            if (y1 < y0) return "↗";
            if (y0 === y1) return "→";
        } else if (x0 > x1){
            if (y1 > y0) return "↙";
            if (y1 < y0) return "↖";
            if (y0 === y1) return "←";
        }
        return "○";
    }

    vecMap(heatMap){
        const ret = [];
        for (let ih = 0;ih < this._height;ih++){
            const tmp = [];
            for (let iw = 0;iw < this._width;iw++){
                const neighbours = this.getNeighbour(iw, ih);
                let minal = 999;
                let minx=0, miny=0;
                for (const n of neighbours){
                    if (ih === 5 && iw === 7){
                       // console.log(n, heatMap[n.y][n.x]);
                    }
                    if (!heatMap[ih][iw]){
                        minal = 0;
                        minx = iw;
                        miny = ih;
                    } else if (heatMap[n.y][n.x] <= minal && heatMap[n.y][n.x] !== null){
                        if (heatMap[n.y][n.x] === minal){
                            if (minx === iw || miny === ih) continue;
                        }
                        minx = n.x;
                        miny = n.y;
                        minal = heatMap[n.y][n.x];
                    }
                }
                if (ih === 5 && iw === 7){
                    //console.log(iw, ih, minx, miny, this.selectDirect(iw, ih, minx, miny));
                }
                tmp.push(this.selectDirect(iw, ih, minx, miny));
            }
            ret.push(tmp);
        }
        return ret;
    }


    mapString(mp, w, h){
        const string_list = [];
        for (let ih = 0;ih < h;ih++){
            const string_line = [];
            for (let iw = 0;iw < w;iw++){
                string_line.push(mp[ih][iw]);
            }
            string_list.push(`[${string_line.join(", ")}]`);
        }
        return `[${string_list.join(",\n ")}]`;
    }

    toString(){
        return this.mapString(this.map, this._width, this._height);
    }
}

function Map(width, height){
    return new __Map(width, height);
}

